/**
 * 
 */
package org.icroco.tablemodel;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * This annotation is dedicated to Class definition and can be used to set global preference for {@link IBeanTableModel}.
 * @author ouaibsky@gmail.com
 *
 */
@Documented
@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
public @interface ABeanTableModel 
{
	/**
	 * @return if we have to synchronize method which update the model. it can occurs into 2 use cases:
	 * <ul>
	 * <li>If your model can be modify from view component (JTable) and programmaticly from another thread</li>
	 * <li>If your model can be modify from many thread.</li>
	 * </ul> 
	 * default is true.
	 */
	boolean	isTreadSafe() default false;
}
