/**
 * 
 */
package org.icroco.tablemodel.impl.blinking;

import java.awt.Color;

import org.icroco.tablemodel.blinking.ABlinking;
import org.icroco.tablemodel.blinking.EBlinkingMode;
import org.icroco.tablemodel.impl.TableModelProperty;

/**
 * @author ouaibsky@gmail.com
 * 
 */
public final class TableModelBlinkProperty
		extends TableModelProperty
{
	private boolean blink;
	private EBlinkingMode mode;
	private Color blinkBgColor;
	private Color blinkFgColor;
	private int duration;
	private int repeat;

	/**
	 * 
	 */
	public TableModelBlinkProperty()
	{
		super();
		this.blink = false;
		this.blinkBgColor = Color.decode(ABlinking.DEFAULT_BG_COLOR);
		this.blinkFgColor = null;
		this.mode = EBlinkingMode.COLOR;
		this.repeat = 1;
		this.duration = 500;
	}

	/**
	 * @return the blinkBgColor
	 */
	final Color getBlinkBgColor()
	{
		return blinkBgColor;
	}

	/**
	 * @return the blinkFgColor
	 */
	final Color getBlinkFgColor()
	{
		return blinkFgColor;
	}

	/**
	 * @return the duration
	 */
	final int getDuration()
	{
		return duration;
	}

	/**
	 * @return the mode
	 */
	final EBlinkingMode getMode()
	{
		return mode;
	}

	
	
	/**
	 * @return the repeat
	 */
	final int getRepeat()
	{
		return repeat;
	}

	/**
	 * @return the blink
	 */
	final boolean isBlink()
	{
		return blink;
	}

	/**
	 * @param aBlink
	 *            the blink to set
	 */
	final void setBlink(boolean aBlink)
	{
		blink = aBlink;
	}

	/**
	 * @param aBlinkBgColor
	 *            the blinkBgColor to set
	 */
	final void setBlinkBgColor(Color aBlinkBgColor)
	{
		blinkBgColor = aBlinkBgColor;
	}

	/**
	 * @param aBlinkFgColor the blinkFgColor to set
	 */
	final void setBlinkFgColor(Color aBlinkFgColor)
	{
		blinkFgColor = aBlinkFgColor;
	}

	/**
	 * @param aDuration the duration to set
	 */
	final void setDuration(int aDuration)
	{
		duration = aDuration;
	}

	/**
	 * @param aMode the mode to set
	 */
	final void setMode(EBlinkingMode aMode)
	{
		mode = aMode;
	}

	/**
	 * @param aRepeat the repeat to set
	 */
	final void setRepeat(int aRepeat)
	{
		repeat = aRepeat;
	}

	@Override
	public String toString()
	{
		if (isBlink())
			return super.toString() + " blink:'" + isBlink() + "' blinkMode:'" + mode + "' duration:'" + duration + "' repeat:'" + repeat
			+ "' bgColor:'" + blinkBgColor + "' fgColor:'" + blinkFgColor + "'";
		else
			return super.toString() + " blink:'" + isBlink();
	}

}
